#define APPNAME  "Tutorial_02"
#define APPTITLE "Tutorial_02"

#define _RELEASE_(p) { if(p) { (p)->Release(); (p)=NULL; };}
#define _DELETE_(p)  { if(p) { delete (p);     (p)=NULL; };}

#include <windows.h>
#include <time.h>

#include <d3d8.h>
#pragma comment (lib, "dxguid.lib")
#pragma comment (lib, "d3d8.lib")

BOOL	g_bActive = TRUE;
HWND	g_hWnd = NULL;

LPDIRECT3D8             g_d3d        = NULL; // our main d3d8 interface
LPDIRECT3DDEVICE8       g_d3d_Device = NULL; // our d3d8 device


LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
bool WindowInit(HINSTANCE hInst, int nCmdShow);
HRESULT InitD3D(HWND hWnd);
bool AppInit(HINSTANCE hInst, int nCmdShow);
void DestroyDirect3D8 ();
HRESULT RenderLoop();



LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_ACTIVATE:
		g_bActive = LOWORD(wParam);
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
		{
			DestroyDirect3D8();
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		}
		break;

	case WM_CLOSE:          
		DestroyDirect3D8();
        DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;

	case WM_DESTROY:
		PostQuitMessage (0);
		break;
/*  콺 Ŀ ʿ   Ѵ
	case WM_SETCURSOR:
		SetCursor (NULL);
		break; 
*/
	};
	return DefWindowProc(hWnd, message, wParam, lParam);
}
//-----------------------------------------------------------------------------
bool WindowInit(HINSTANCE hInst, int nCmdShow)
{
	WNDCLASS		    wcl;
		
	wcl.hInstance		= hInst;
	wcl.lpszClassName	= APPNAME;
	wcl.lpfnWndProc		= WindowProc;
	wcl.style			= 0;

	wcl.hIcon			= LoadIcon (NULL, IDC_ICON);
	wcl.hCursor			= LoadCursor (NULL, IDC_ARROW);
	wcl.lpszMenuName	= NULL;

	wcl.cbClsExtra		= 0;
	wcl.cbWndExtra		= 0;
	wcl.hbrBackground	= (HBRUSH) GetStockObject (BLACK_BRUSH);

	RegisterClass (&wcl);

	g_hWnd = CreateWindowEx (
		NULL,
		APPNAME,
		APPTITLE,
		WS_OVERLAPPEDWINDOW,
		0, 0, 
		640,
		480,
		NULL,
		NULL,
		hInst,
		NULL);

	if(!g_hWnd) 
		return false;

	return true;
}
//-----------------------------------------------------------------------------
bool AppInit(HINSTANCE hInst, int nCmdShow)
{
	srand (time(0)); // randomize timer

	if(!WindowInit (hInst, nCmdShow)) 
		return false;

	ShowWindow (g_hWnd, nCmdShow);
	UpdateWindow (g_hWnd);
	
	return true;
}
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	g_d3d = Direct3DCreate8 (D3D_SDK_VERSION);
	
	D3DDISPLAYMODE d3ddm;
    g_d3d->GetAdapterDisplayMode (D3DADAPTER_DEFAULT, &d3ddm );

	D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory (&d3dpp, sizeof(d3dpp));
    d3dpp.Windowed = true;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = d3ddm.Format;

    g_d3d->CreateDevice (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, 
						D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_d3d_Device);

	return S_OK;
}
//-----------------------------------------------------------------------------
void DestroyDirect3D8 ()
{
	_RELEASE_ (g_d3d_Device);
	_RELEASE_ (g_d3d);
}
//-----------------------------------------------------------------------------
HRESULT RenderLoop ()
{
	static int c=0;
    g_d3d_Device->Clear (0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB (0, 0, c++), 1.0f, 0);
    g_d3d_Device->BeginScene ();
    g_d3d_Device->EndScene ();
    g_d3d_Device->Present (NULL, NULL, NULL, NULL);
	return S_OK;
}
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	if(!AppInit(hInst, nCmdShow)) 
		return -1;
	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	
	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            if( g_bActive )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

	UnregisterClass( APPNAME, hInst);
	return 0;
}
//-----------------------------------------------------------------------------